import pickle
import matplotlib.pyplot as plt
import numpy as np
import  moviepy.editor as mpy
from moviepy.video.io.bindings import mplfig_to_npimage



# print(data[-1].shape)
#
# num_elements = len(data[0])
#
#
# fig,ax = plt.subplots()
# # im = ax.imshow(image, cmap='gray')
# plt.plot([1./num_elements * i for i in range(num_elements)], data[-1])
# plt.ylim(-1.1,1.1)
# # fig.colorbar(im)
# # plt.imshow(image, cmap='gray')
#
# plt.show()



class MakeMovie:
    def __init__(self, file_name, data):
        self.file_name = file_name
        self.fig, self.ax = plt.subplots()
        self.data = data
        self.num_points = len(self.data[0])
        self.x_points = [1./self.num_points * i for i in range(self.num_points)]

    def show_frame(self, time):
        self.fig.clf()

        plt.plot(self.x_points, data[time])
        plt.ylim(-1.1, 1.1)
        plt.show()

    def return_time_frame(self, t):
        self.fig.clf()
        time = int(t * 30)

        plt.plot(self.x_points, data[time])
        plt.ylim(-1.1,1.1)

        return mplfig_to_npimage(self.fig)

    def return_time_frame_gradient(self, t):
        self.fig.clf()
        time = int(t * 30)

        plt.plot(self.x_points, np.gradient(data[time]))
        plt.ylim(-1.1,1.1)

        return mplfig_to_npimage(self.fig)

    def make_movie(self):
        duration = (len(self.data) - 1) / 30

        animation = mpy.VideoClip(self.return_time_frame, duration=duration)

        animation.write_videofile(self.file_name, fps=30)

    def make_movie_gradient(self):
        duration = len(self.data) / 30

        animation = mpy.VideoClip(self.return_time_frame_gradient, duration=duration)

        animation.write_videofile(self.file_name, fps=30)



if __name__ == "__main__":
    with open("test_storage1DReflective.pickle", 'rb') as handle:
    # with open("test_storage1D_Dirichlet.pickle", 'rb') as handle:
        data = pickle.load(handle)

    movie_maker = MakeMovie("test_movie_file1DReflective.mp4", data)
    movie_maker.make_movie()
    # movie_maker.make_movie_gradient()
    # movie_maker.show_frame(200)
